PROGRAM SIMIL(INPUT,OUTPUT,ENTREEC,SORTIE,PROBAB,PART);
LABEL 777;
CONST MAXCALCUL=1000;
      MAXMAT= 70;    (* MAX FOR D05,S23 *)
      MAXMAT1=2556;  (* (MAXMAT +1)(MAXMAT+2)/2 *)
      NBBITS=59;     (* NUMBER OF BITS IN A COMPUTER WORD *)
      NBBITS1=58;    (* NBBITS-1 *)
      NBCHAR=10;     (* NUMBER OF CHARACTERS THAT CAN FIT IN ONE WORD *)
      MAXBITS=58999; (* NBBITS*MAXCALCULS-1 *)
      EPSILON=0.00000001;
      MAXREEL=1.70E38; (* MAXIMUM FOR THIS COMPUTER *)
      NBMOTS=1;      (* NBMOTS X NBCAR >=10 *)
      NBCAR=10;      (* NUMBER OF CHARACTERS IN ONE MEMORY WORD *)
      LANG=1;        (* Parametre de langue: 1=FRANCAIS
                        Language parameter : 2=ENGLISH  *)
TYPE ENSEMBLE=SET OF 0..NBBITS1;
TYPE MAT0=ARRAY[1..MAXCALCUL] OF REAL;
     ALFA=PACKED ARRAY[1..10] OF CHAR;
     ALPHA=PACKED ARRAY[1..11] OF CHAR; (* CORRECTION VAX *)
     PTRMAT=@MAT0;
     MULTIPLE=RECORD CASE INTEGER OF
             1:(INT:INTEGER);
             2:(RE:REAL);
             3:(MATCAR:PACKED ARRAY[1..NBCAR] OF CHAR);
             END;
     MULTFICH=FILE OF MULTIPLE;
     ENS=SET OF 0..NBBITS1;
     MATBITS=ARRAY[0..MAXCALCUL] OF ENS;
     PTRBITS=@MATBITS;
     MATINT=ARRAY[1..MAXCALCUL] OF INTEGER;
     PTRINT=@MATINT;
     MATREEL=ARRAY[1..MAXMAT1] OF REAL;
     PTRMATREEL=@MATREEL;
     MATIDENT=ARRAY[1..MAXCALCUL] OF ALFA;
     PTRIDENT=@MATIDENT;
     MATBOOL=ARRAY[1..MAXCALCUL] OF BOOLEAN;
     PTRBOOL=@MATBOOL;
     LINK=@MATPART;
     MATPART=RECORD
             INT1,INT2:INTEGER;
             LIEN:LINK;
             END;
VAR NBDESC,NOBJ,FONCTION,NBMOT,NBGROUPES,NBIDENT,OPTION:INTEGER;
    MAT1,MAT2,MAT3,MAT4:PTRMAT;
    MATB1,MATB2,MATABS1,MATABS2:PTRBITS;
    MATINT1,MATINT2:PTRINT;
    MATID:PTRIDENT;
    MULTCLASS:PTRBOOL;
    PROCHAIN:LINK;
    TITRE:ARRAY[1..10]OF ALFA;
    FONC,DATE1,VIDE,IDENTIFICATEUR:ALFA;
    DATE2:ALPHA; (* CORRECTION VAX *)
    ABSENCE,PUISSANCE:REAL;
    QUANTITATIF,WILKS,WRONG,GROUPE,PROBABILITE,IDENTLIGNE:BOOLEAN;
    ENTREEC,PART:TEXT;
    BIN,TEMP,TEMP1:FILE OF REAL;
    BINTEMP:FILE OF ENS;
    SORTIE,PROBAB:MULTFICH;

FUNCTION CARD(A:ENSEMBLE):INTEGER;
VAR I,COMPTE:INTEGER;
BEGIN
COMPTE:=0;
FOR I:=0 TO NBBITS1 DO IF I IN A THEN
   COMPTE:=COMPTE+1;
CARD:=COMPTE;
END;

PROCEDURE ERREUR(I,J,K:INTEGER);
BEGIN
WRITE(' FATAL ERROR ');
IF LANG=1 THEN BEGIN
CASE I OF
    1:WRITELN(' FICHIER D''ENTREE VIDE ');
    2:WRITELN(' DESCRIPTEUR ',J:3,' VIDE');
    3:WRITELN(' SOMME EGALE ZERO, LIGNES ',J:3,' ET ',K:3);
    5:WRITELN(' SOMME DE LA CARDINALITE DES GROUPES PLUS GRANDE QUE',
              ' LE NOMBRE D''OBJETS ');
    6:WRITELN(' DEGRES DE LIBERTE < 1, OU VARIANCE = 0, GROUPE ',J:3,
              ', DESCRIPTEUR ',K:3);
    7:WRITELN(' TROP DE VARIABLES POUR CETTE FONCTION. RE-DIMENSIONNEZ',
              ' LE PROGRAMME');
    8:BEGIN
      WRITE(' CETTE FONCTION EXIGE DES DONNEES POSITIVES, LIGNE: ',J:3);
      WRITELN(' COLONNE: ',K:3);
      END;
    9:WRITELN(' VECTEUR VIDE, GROUPE ',J:3,' LIGNE ',K:3);
  10:WRITELN(' ABSENCE D''INFORMATION NON PERMISE POUR CE COEFFICIENT');
   11:WRITELN(' PAS DE VARIATION DES COLONNES SUR TOUT LE FICHIER ');
   12:BEGIN
      WRITE(' VALEUR DE LA MATRICE PARTIELLE < 0 OU > 1, MATRICE ',J:3);
      WRITELN(', ',K:3,'IEME VALEUR ');
      END;
 13:WRITELN(' VALEUR > ORDRE DE LA MATRICE PARTIELLE, LIGNES ',J:3,K:3);
   14:BEGIN WRITE
      (' CODE ZERO NON PERMIS POUR UNE MATRICE PARTIELLE: LIGNES ');
      WRITELN(J:3,K:3);
      END;
   END;
END ELSE BEGIN CASE I OF
    1:WRITELN(' DATA FILE EMPTY ');
    2:WRITELN(' DESCRIPTOR ', J:3,' EMPTY');
    3:WRITELN(' THE SUM OF ONE OF THESE LINES IS ZERO: ',J:3,K:3);
    5:WRITELN(' SUM OF GROUP CARDINALITIES > NUMBER OF OBJECTS');
    6:WRITELN(' D.F. < 1 OR VARIANCE OF GROUP ',J:3,'IS ZERO, FOR',
              ' DESCRIPTOR ',K:3);
    7:WRITELN(' TOO MANY VARIABLES FOR THIS FUNCTION ');
    8:BEGIN
      WRITE(' THIS FUNCTION REQUIRES POSITIVE DATA ONLY: LINE ',J:3);
      WRITELN(' COLUMN: ',K:3);
      END;
    9:WRITELN(' EMPTY VECTOR, GROUP ',J:3,' LINE ',K:3);
   10:WRITELN(' MISSING VALUES NOT ALLOWED FOR THIS COEFFICIENT');
   11:WRITELN(' NO VARIATION IN THE COLUMNS OF THIS DATA FILE');
   12:BEGIN
      WRITE(' PARTIAL SIMILARITY VALUE < 0 OR > 1 IN MATRIX ',J:3);
      WRITELN(', ',K:3,'th VALUE');
      END;
   13:WRITELN(' VALUE > SIZE OF PARTIAL SIMILARITY MATRIX: ',J:3,K:3);
   14:BEGIN
      WRITE(' CODE ZERO NOT ALLOWED FOR PARTIAL SIM. MATRIX: LINES ');
      WRITELN(J:3,K:3);
      END;
END;END;
GOTO 777;
END;  (* ERREUR *)

PROCEDURE ERRNONFAT(I,J,K:INTEGER);
BEGIN
IF LANG=1 THEN BEGIN
WRITE(' ATTENTION! ');
CASE I OF
    1:WRITELN(' DESCRIPTEUR ',J:3,' VARIATION = 0 ');
   2:WRITELN(' CALCUL SUR ',J:3,K:3,': ABSENCE D''INFORMATION PARTOUT');
   3:WRITELN(' PROBABILITE POUR ',J:3,K:3,' INCALCULABLE (D.L. < 1 ?)');
    4:WRITELN(' COEFFICIENT POUR ',J:3,K:3,' INCALCULABLE ');
    5:WRITE  (' GROUPES ',J:3,K:3,' VECTEUR NUL: ');
    6:WRITELN(' LIGNES ',J:3,K:3,' VARIANCE NULLE ');
    7:WRITELN(' COLONNE ',J:3,': VARIATION NULLE ');
    8:WRITELN(' CETTE FONCTION N''EXISTE PAS ');
END; END ELSE BEGIN
WRITE(' CAREFUL! ');     (* MODIFICATION *)
CASE I OF
    1:WRITELN(' DESCRIPTOR ',J:3,' VARIATION = 0 ');
    2:WRITELN(' LINES ',J:3,K:3,': MISSING VALUES EVERYWHERE' );
    3:WRITELN(' I CANNOT COMPUTE PROB. FOR ',J:3,K:3,' ( D.F. < 1 ?)');
    4:WRITELN(' I CANNOT COMPUTE THIS COEFFICIENT FOR ',J:3,K:3);
    5:WRITE  (' GROUPS ',J:3,K:3,' NULL VECTOR: ');
    6:WRITELN(' LINES ',J:3,K:3,' NULL VARIANCE');
    7:WRITELN(' COLUMN ',J:3,' NO VARIATION');
    8:WRITELN(' THIS FUNCTION DOES NOT EXIST');
END;END;
END;(* ERREUR NON FATALE *)

PROCEDURE ECRITINT(X:INTEGER;VAR FICH:MULTFICH);
VAR Y:MULTIPLE;
BEGIN
Y.INT:=X;
FICH@:=Y;
PUT(FICH);
END;

PROCEDURE ECRITREEL(X:REAL;VAR FICH:MULTFICH);
VAR Y:MULTIPLE;
BEGIN
Y.RE:=X;
FICH@:=Y;
PUT(FICH);
END;

PROCEDURE ECRITCHAR(X:ALFA;VAR FICH:MULTFICH);
VAR Y:MULTIPLE;
    I,J:INTEGER;
BEGIN
J:=0;
FOR I:=1 TO NBCHAR DO
      BEGIN
      J:=J+1;
      Y.MATCAR[J]:=X[I];
      IF J=NBCAR THEN
            BEGIN
            J:=0;
            FICH@:=Y;
            PUT(FICH);
            END;
      END;
IF J<>0 THEN
      BEGIN
      FICH@:=Y;
      PUT(FICH);
      END;
END;

PROCEDURE SHELLSORT(VAR A,B: MAT0;LIM,N: INTEGER);
LABEL 1;
VAR I,J,K,L,M,O: INTEGER;
    W:REAL;
BEGIN
M:=2*(N-LIM)+1 DIV 2;
WHILE M<>0 DO
         BEGIN
         K:=N-M;
         FOR J:=LIM TO K DO
                 BEGIN
                 I:=J;
                 WHILE I>=LIM DO
                        BEGIN
                        IF A[I+M]>=A[I] THEN GOTO 1;
                        O:=I+M;
                        W:=A[I];A[I]:=A[O];A[O]:=W;
                        W:=B[I];B[I]:=B[O];B[O]:=W;
                        I:=I-M;
                        END;
 1:                 END;
         M:=M  DIV 2;
         END;
END;         (* FIN DE SHELLSORT *)

PROCEDURE TRANSPOSE;
VAR I,J,K:INTEGER;
BEGIN
REWRITE(TEMP);
FOR I:=1 TO NBDESC DO
      BEGIN
      RESET(BIN);
      FOR J:=1 TO NOBJ DO
            BEGIN
            FOR K:=2 TO I DO GET(BIN);
            TEMP@:=BIN@;
            PUT(TEMP);
            FOR K:=I TO NBDESC DO GET(BIN);
            END;
      END;
END;   (* FIN TRANSPOSE *)

PROCEDURE ENTREIDENT;
VAR I:INTEGER;
BEGIN
IF NBIDENT>0 THEN READLN(ENTREEC);
FOR I:=1 TO NBCHAR DO READ(ENTREEC,IDENTIFICATEUR[I]);
NBIDENT:=NBIDENT+1;
MATID@[NBIDENT]:=IDENTIFICATEUR;
END;   (* FIN ENTREIDENT *)

PROCEDURE BINARISE;
VAR I,J:INTEGER;
   X:REAL;
    POSITIF,NONABSENCE:BOOLEAN;
BEGIN
RESET(ENTREEC);
REWRITE(BIN);
POSITIF:=FONCTION IN[17,18,21,22,23,34,35,36,39];
NONABSENCE:=FONCTION=23;
FOR I:=1 TO NOBJ DO
      BEGIN
      IF IDENTLIGNE THEN ENTREIDENT;
      FOR J:=1 TO NBDESC DO
            BEGIN
            READ(ENTREEC,X);
           IF (((POSITIF)AND(X<>ABSENCE))AND(X < 0)) THEN ERREUR(8,I,J);
            IF ((NONABSENCE)AND(X=ABSENCE)) THEN ERREUR(10,I,J);
            BIN@:=X;
            PUT(BIN);
            END;
      END;
END;   (* BINARISE *)

PROCEDURE ECART(VAR MAT:MAT0);
VAR I,J:INTEGER;
   MAT1:PTRMAT;
   X:REAL;
BEGIN
NEW(MAT1);
RESET(BIN);
FOR J:=1 TO NBDESC DO
      BEGIN
      X:=BIN@;
      GET(BIN);
      IF X<>ABSENCE THEN BEGIN MAT[J]:=X;MAT1@[J]:=X;END
      ELSE BEGIN MAT[J]:=-1;MAT1@[J]:=0;END;
      END;
FOR I:=2 TO NOBJ DO
      BEGIN
      FOR J:=1 TO NBDESC DO
            BEGIN
            X:=BIN@;
            GET(BIN);
            IF X<>ABSENCE THEN
                  BEGIN
                  IF ((X > MAT[J])OR(MAT[J]=-1)) THEN MAT[J]:=X;
                  IF X <MAT1@[J] THEN MAT1@[J]:=X;
                END;
            END;
      END;
FOR I:=1 TO NBDESC DO
      BEGIN
      MAT[I]:=MAT[I]-MAT1@[I];
      IF MAT[I]=0 THEN
            BEGIN
            MAT[I]:=1;
            ERRNONFAT(1,I,0);
            END
      ELSE IF MAT[I]= -1 THEN ERREUR(2,I,0);
      END;
DISPOSE(MAT1);
END;   (* FIN ECART MAX *)

FUNCTION FISHER(A,B,C,D:REAL):REAL;
VAR I,J,L,A1,B1,C1,D1,N1:INTEGER;
    X:REAL;

   FUNCTION ARRONDIT(X:REAL):INTEGER;
   BEGIN
   ARRONDIT:=TRUNC(X+0.5);
   END;

BEGIN
X:=0;
A1:=ARRONDIT(A);
B1:=ARRONDIT(B);
C1:=ARRONDIT(C);
D1:=ARRONDIT(D);
N1:=A1+B1+C1+D1;
FOR I:=A1+B1+1 TO N1 DO X:=X-LN(I);
FOR I:=A1+1 TO A1+C1 DO X:=X+LN(I);
FOR I:=B1+1 TO B1+D1 DO X:=X+LN(I);
FOR I:=C1+1 TO C1+D1 DO X:=X+LN(I);
FOR I:=2 TO D1 DO X:=X-LN(I);
FISHER:=EXP(X);
END;      (* FIN DE FISHER *)

FUNCTION GAUSS(X:REAL):REAL;
VAR Y,Z,W:REAL;
BEGIN
                              (* REFERENCE: CACM                *)
                              (* ALGORITHME: 209                *)
                              (* AUTEUR:D.IBBETSON              *)
                              (* TITRE:GAUSS                    *)
                              (* TRADUIT EN PASCAL PAR A.VAUDOR *)
IF X=0 THEN Z:=0
ELSE
      BEGIN
      Y:=ABS(X)/2;
      IF Y>=3 THEN Z:=1
      ELSE IF Y<1 THEN
            BEGIN
            W:=Y*Y;
            Z:=((((((((0.000124818987*W
            -0.001075204047)*W+0.005198775019)*W
            -0.019198292004)*W+0.059054035642)*W
            -0.151968751364)*W+0.319152932694)*W
            -0.531923007300)*W+0.797884560593)*Y*2
            END
          ELSE
            BEGIN
            Y:=Y-2;
            Z:=(((((((((((((-0.000045255659*Y
            +0.000152529290)*Y-0.000019538132)*Y
            -0.000676904986)*Y+0.001390604284)*Y
            -0.000794620820)*Y-0.002034254874)*Y
            +0.006549791214)*Y-0.010557625006)*Y
            +0.011630447319)*Y-0.009279453341)*Y
            +0.005353579108)*Y-0.002141268741)*Y
            +0.000535310849)*Y+0.999936657524
            END
      END;
IF X>0 THEN GAUSS:=(Z+1)/2 ELSE GAUSS:=(1-Z)/2;
END;      (* GAUSS *)

FUNCTION ZTEST(X:REAL):REAL;
VAR Y,Z:REAL;
BEGIN
X:=ABS(X);
Y:=EXP(-X*X/2)*0.3989423;
Z:=1/(1+X*0.2316419);
Z:=2*Y*Z*((((1.330274*Z-1.821256)*Z+1.781478)*Z-0.3565638)*Z+0.3193815);
ZTEST:=1-Z;
END;


FUNCTION FTEST(F:REAL;DF1,DF2:INTEGER;VAR ERROR:BOOLEAN):REAL;
LABEL 33;
VAR F1,F2,X,FT,VP,XX,THETA,STH,CTH,STS,CTS,A,B,XI,GAMMA,CBRF:REAL;
BEGIN
                              (* REFENCE:CACM                   *)
                              (* ALGORITHME:346                 *)
                              (* AUTEUR:J.MORRIS                *)
                              (* TITRE:FTEST PROBABILITIES      *)
                              (* TRADUIT EN PASCAL PAR A.VAUDOR *)
ERROR:=FALSE;
IF (((DF1<1) OR((DF2<1)OR(F<0)))OR(F>=MAXREEL)) THEN
            BEGIN FTEST:=0; ERROR:=TRUE;GOTO 33;END;
IF F=0 THEN FTEST:=1.0
ELSE
      BEGIN
      F1:=DF1;F2:=DF2;FT:=0;
      X:=F2/(F2+F1*F);VP:=F1+F2-2.0;
      IF ((DF1 MOD 2 =0) AND (DF1<500)) THEN
            BEGIN
            XX:=1-X;
            F1:=F1-2;
            WHILE F1>1 DO
                  BEGIN
                  VP:=VP-2;
                  FT:=XX*VP/F1*(1+FT);
                  F1:=F1-2;
                  END;
            IF X<>0 THEN FT:=EXP((0.5*F2)*LN(X))*(1+FT) ELSE FT:=0;
            END
      ELSE IF ((DF2 MOD 2=0)AND(DF2<500)) THEN
            BEGIN
             F2:=F2-2;
            WHILE F2>1 DO
                  BEGIN
                  VP:=VP-2;
                  FT:=X*VP/F2*(1.0+FT);
                  F2:=F2-2;
                  END;
            IF X<>1 THEN FT:=1-EXP((0.5*F1)*LN(1-X))*(1+FT) ELSE FT:=1;
            END
            ELSE IF DF1+DF2<=500 THEN
                  BEGIN
                  THETA:=ARCTAN(SQRT(F1*F/F2));
                  STH:=SIN(THETA);CTH:=COS(THETA);
                  STS:=SQR(STH);CTS:=SQR(CTH);
                  A:=0;B:=0;
                  IF DF2>1 THEN
                        BEGIN
                        F2:=F2-2.0;
                        WHILE F2>2 DO
                              BEGIN
                              A:=CTS*(F2-1.0)/F2*(1.0+A);
                              F2:=F2-2;
                              END;
                        A:=STH*CTH*(1.0+A);
                        END;
                  A:=THETA+A;
                  IF DF1>1 THEN
                        BEGIN
                        F1:=F1-2;
                        WHILE F1>2 DO
                              BEGIN
                              VP:=VP-2;
                              B:=STS*VP/F1*(1.0+B);
                              F1:=F1-2;
                              END;
                        GAMMA:=1.0;F2:=0.5*DF2;
                        XI:=1;
                        WHILE XI<=F2 DO
                              BEGIN
                              GAMMA:=XI*GAMMA/(XI-0.5);
                              XI:=XI+1;
                              END;
                        B:=GAMMA*STH*EXP(DF2*LN(CTH))*(1.0+B);
                        END;
                  FT:=1.0+0.636619772368*(B-A);
                  END
      ELSE
            BEGIN
            F1:=2.0/(9.0*F1);F2:=2.0/(9.0*F2);
            CBRF:=(EXP(LN(F)/3));
            FT:=GAUSS(-((1.0-F2)*CBRF+F1-1.0)/SQRT(F2*SQRT(CBRF)+F1));
            END;
      IF FT<0 THEN FTEST:=0 ELSE FTEST:=FT;
      END;
33:END;   (* FTEST *)


FUNCTION CHIPROB(X:REAL;F:INTEGER;BIGX:BOOLEAN;VAR WRONG:BOOLEAN):REAL;
VAR A,Y,S,E,C,Z:REAL;
    EVEN:BOOLEAN;
BEGIN
WRONG:=FALSE;
IF ((X<0)OR (F<1)) THEN
      BEGIN
      WRONG:=TRUE;
      CHIPROB:=0;
      END
ELSE
   IF X=0 THEN CHIPROB:=1
   ELSE
      BEGIN
      A:=0.5*X;EVEN:=2*(F DIV 2)=F;
      IF ((EVEN) OR((F>2) AND (NOT BIGX))) THEN Y:=EXP(-A);
      IF EVEN THEN S:=Y ELSE S:=2*(GAUSS(-SQRT(X)));
      IF F>2 THEN
            BEGIN
            X:=0.5*(F-1);
            IF EVEN THEN Z:=1 ELSE Z:=0.5;
            IF BIGX THEN
                  BEGIN
                  IF EVEN THEN E:=0 ELSE E:=0.572364842925;
                  C:=LN(A);
                  WHILE Z<X DO
                        BEGIN
                        E:=LN(Z)+E;
                        S:=EXP(C*Z-A-E)+S;
                        Z:=Z+1;
                        END;
                  CHIPROB:=S;
                  END
            ELSE
                  BEGIN
                  IF EVEN THEN E:=1 ELSE E:=0.564189583548/SQRT(A);
                  C:=0;
                  WHILE Z<X DO
                        BEGIN
                        E:=E*A/Z;
                        C:=C+E;
                        Z:=Z+1;
                        END;
                  CHIPROB:=C*Y+S;
                  END
            END
      ELSE CHIPROB:=S;
      END;
END;      (* CHIPROB *)

FUNCTION LINRES
(N,Q1,Q2:INTEGER;VAR C:MATREEL;VAR LAST,ABSENCE,GR1,GR2:INTEGER):REAL;
VAR I,J,K,L,M,Q:INTEGER;
    X,Y:REAL;
BEGIN
ABSENCE:=0;
                 (* REFERENCE:ZASTOSOWANIA MATEMATIKI                 *)
                 (* ALGORITHME 44                                     *)
                 (* AUTEUR:ANNA BARTOWIAK                             *)
                 (* TITRE:AN ABREVIATED METHOD OF CALCULATING THE     *)
                 (* MAHALANOBIS DISTANCE OR RESIDUAL SUM OF SQUARES   *)
                 (* IN A LINEAR REGRESSION MODEL.                     *)
                 (* TRADUIT EN PASCAL PAR A VAUDOR.                   *)
IF Q1>LAST THEN
      BEGIN
      K:=Q1*(Q1-1) DIV 2;
      M:=(SQR(N)+N) DIV 2;
      FOR Q:=Q1 TO Q2 DO
            BEGIN
            K:=K+Q;
            X:=C[K];
            IF ABS(X)<=0.0000000001 THEN
                  BEGIN
            (* LIGNES SUIVANTES RAJOUTEES PAR A VAUDOR POUR COMPENSER *)
            (* LES CAS OU UN VECTEUR EST FONCTION LINEAIRE DES AUTRES *)
                  ERRNONFAT(5,GR1,GR2);
                  WRITELN(Q:4);
                  ABSENCE:=ABSENCE+1;
                  END
            ELSE
                  BEGIN
                  X:=-1/X;
                  L:=K+Q;
                   FOR I:=Q+1 TO N DO
                        BEGIN
                        C[I+M]:=C[L];
                        Y:=X*C[L];
                        FOR J:= Q+1 TO I DO
                              BEGIN
                              L:=L+1;
                              C[L]:=C[L]+Y*C[J+M];
                              END;
                        L:=L+Q;
                        END;
                  END;
            END;
      LAST:=Q2;
      LINRES:=C[N*(N+1) DIV 2];
      END;
END;    (* FIN LINRES *)

PROCEDURE ENTROPIE
(VAR A,B,C,P:REAL;VAR DF:INTEGER;LIGNE1,LIGNE2:INTEGER);
VAR I,J,K,COMPTEUR1,COMPTEUR,NBLIGNES,NBCOL:INTEGER;
    X,Y,TOTAL,MARGCOL,MARGLIGNE,CARDCASE:REAL;
BEGIN
DF:=0;A:=0;B:=0;C:=0;NBLIGNES:=0;NBCOL:=0;
CARDCASE:=0;MARGCOL:=0;MARGLIGNE:=0;TOTAL:=0;
FOR I:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[I];
      Y:=MAT2@[I];
      IF ((X=ABSENCE)OR(Y=ABSENCE)) THEN
            BEGIN
            MAT2@[I]:=ABSENCE;
            X:=ABSENCE;
            END;
      MAT3@[I]:=X;
      END;
FOR I:=1 TO NBDESC DO
      BEGIN
      X:=MAT3@[I];
      COMPTEUR:=1;
      IF X<>ABSENCE THEN
            BEGIN
            COMPTEUR:=1;
            MAT4@[1]:=MAT2@[I];
            FOR J:=I+1 TO NBDESC DO
                  BEGIN
                  IF MAT3@[J]=X THEN
                        BEGIN
                        COMPTEUR:=COMPTEUR+1;
                        MAT4@[COMPTEUR]:=MAT2@[J];
                        MAT3@[J]:=ABSENCE;
                        END;
                  END;
            MARGCOL:=MARGCOL+COMPTEUR*LN(COMPTEUR);
            NBCOL:=NBCOL+1;
            TOTAL:=TOTAL+COMPTEUR;
            FOR J:=1 TO COMPTEUR DO
                  BEGIN
                  Y:=MAT4@[J];
                  IF Y<>ABSENCE THEN
                        BEGIN
                        COMPTEUR1:=1;
                        FOR K:=J+1 TO COMPTEUR DO
                              BEGIN
                              IF MAT4@[K]=Y THEN
                                    BEGIN
                                    COMPTEUR1:=COMPTEUR1+1;
                                    MAT4@[K]:=ABSENCE;
                                    END;
                              END;
                        CARDCASE:=CARDCASE+COMPTEUR1*LN(COMPTEUR1);
                        END;
                  END;
            END;
      END;
IF TOTAL > 0 THEN
      BEGIN
      FOR I:=1 TO NBDESC DO
            BEGIN
            X:=MAT2@[I];
            IF X<>ABSENCE THEN
                  BEGIN
                  COMPTEUR:=1;
                  FOR J:=I+1 TO NBDESC DO IF MAT2@[J]=X THEN
                        BEGIN
                        COMPTEUR:=COMPTEUR+1;
                        MAT2@[J]:=ABSENCE;
                        END;
                  MARGLIGNE:=MARGLIGNE+COMPTEUR*LN(COMPTEUR);
                  NBLIGNES:=NBLIGNES+1;
                  END;
            END;
      DF:=(NBLIGNES-1)*(NBCOL-1);
      P:=TOTAL;
      TOTAL:=TOTAL*LN(TOTAL);
      A:=(MARGCOL-CARDCASE)/P;
      C:=(MARGLIGNE-CARDCASE)/P;
      B:=(TOTAL-MARGLIGNE-MARGCOL+CARDCASE)/P;
      END;
END;  (* FIN ENTROPIE *)

FUNCTION TAU(LIGNE1,LIGNE2:INTEGER;VAR NBPRESENTS:INTEGER):REAL;
VAR I,J,K,L,CL1,CL2,P,Q,LIENS1,LIENS2,LIEN,DEPART,IMOINS1:INTEGER;
    X,Y:REAL;

   PROCEDURE CALCULEPQ;
   VAR J,K,L:INTEGER;
   BEGIN
   IF DEPART < IMOINS1 THEN SHELLSORT(MAT3@,MAT2@,DEPART,IMOINS1);
   FOR J:=DEPART TO IMOINS1 DO
         BEGIN
         K:=TRUNC(MAT3@[J]+0.5);
         MATINT1@[K]:=MATINT1@[K]-1;
         END;
   FOR J:=DEPART TO IMOINS1 DO
         BEGIN
         K:=TRUNC(MAT3@[J]+0.5);
         FOR L:=K-1 DOWNTO 1 DO Q:=Q+MATINT1@[L];
         FOR L:=K+1 TO CL1 DO P:=P+MATINT1@[L];
         END;
   END; (* FIN CALCULS P ET Q *)

BEGIN
P:=0;Q:=0;
NBPRESENTS:=0;
FOR I:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[I];
      Y:=MAT2@[I];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            MAT3@[NBPRESENTS]:=MAT1@[I];
            MAT2@[NBPRESENTS]:=MAT2@[I];
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      TAU:=0;
      END
ELSE
      BEGIN
      SHELLSORT(MAT3@,MAT2@,1,NBPRESENTS);
      X:=MAT3@[1];LIEN:=1;LIENS1:=0;CL1:=1;
      FOR I:=2 TO NBPRESENTS DO
            BEGIN
            MAT3@[I-1]:=CL1;
            IF X<>MAT3@[I] THEN
                  BEGIN
                  LIENS1:=LIENS1+LIEN*(LIEN-1);
                  MATINT1@[CL1]:=LIEN;
                  CL1:=CL1+1;
                  LIEN:=1;
                  X:=MAT3@[I];
                  END
            ELSE
                  BEGIN
                  LIEN:=LIEN+1;
                  END;
            END;
      LIENS1:=LIENS1+LIEN*(LIEN-1);
      MAT3@[NBPRESENTS]:=CL1;
      MATINT1@[CL1]:=LIEN;
      SHELLSORT(MAT2@,MAT3@,1,NBPRESENTS);
      DEPART:=1;CL2:=1;X:=MAT2@[1];LIEN:=1;
      LIENS2:=0;
      FOR I:=2 TO NBPRESENTS DO
            BEGIN
            IF X<>MAT2@[I] THEN
                  BEGIN
                  IMOINS1:=I-1;
                  LIENS2:=LIENS2+LIEN*(LIEN-1);
                  CL2:=CL2+1;
                  CALCULEPQ;
                  LIEN:=1;
                  DEPART:=I;
                  X:=MAT2@[I];
                  END
            ELSE
                  BEGIN
                  LIEN:=LIEN+1;
                  END;
            END;
      LIENS2:=LIENS2+LIEN*(LIEN-1);
      IMOINS1:=NBPRESENTS;
      CALCULEPQ;
      X:=(NBPRESENTS*(NBPRESENTS-1)-LIENS1)*0.5;
      Y:=(NBPRESENTS*(NBPRESENTS-1)-LIENS2)*0.5;
      P:=P-Q;
      IF ((X=0)OR(Y=0)) THEN
            BEGIN
            ERRNONFAT(6,LIGNE1,LIGNE2);
            TAU:=0;
            END
      ELSE
            BEGIN
            IF ((OPTION=1)OR(CL1=CL2)) THEN
              TAU:=P/SQRT(X)/SQRT(Y)
            ELSE
                  BEGIN
                  IF CL1>CL2 THEN CL1:=CL2;
                  TAU:=P*CL1*2/(NBPRESENTS*NBPRESENTS)/(CL1-1);
                  END;
            END;
      END;
END;   (* FIN TAU DE KENDALL *)

FUNCTION RDEPEARSON(LIGNE1,LIGNE2:INTEGER;VAR NBPRESENTS:INTEGER):REAL;
(* This function is used for Nei's genetic similarity as well as for
Pearson's linear correlation coefficient *)
VAR COLONNE:INTEGER;
    X,Y,SUMX,SUMY,SUMX2,SUMY2,SUMXY:REAL;
BEGIN
NBPRESENTS:=0;
SUMX:=0;SUMY:=0;SUMX2:=0;SUMY2:=0;SUMXY:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            SUMX:=SUMX+X;
            SUMY:=SUMY+Y;
            SUMX2:=SUMX2+X*X;
            SUMY2:=SUMY2+Y*Y;
            SUMXY:=SUMXY+X*Y;
            NBPRESENTS:=NBPRESENTS+1;
            END;
      END;
IF NBPRESENTS<1 THEN
      BEGIN
      RDEPEARSON:=0;
      ERRNONFAT(2,LIGNE1,LIGNE2);
      END
ELSE
   BEGIN
     IF FONCTION = 51 THEN                                     (* Nei *)
     X:=SQRT((SUMX2-SUMX*SUMX/NBPRESENTS)*(SUMY2-SUMY*SUMY/NBPRESENTS))
     ELSE X:=SQRT(SUMX2*SUMY2);                                (* Nei *)
     IF X>0 THEN
        BEGIN                                                  (* Nei *)
           IF FONCTION = 51 THEN                               (* Nei *)
           RDEPEARSON:=(SUMXY-SUMX*SUMY/NBPRESENTS)/X
           ELSE RDEPEARSON:=SUMXY/X;                           (* Nei *)
        END                                                    (* Nei *)
     ELSE
        BEGIN
        RDEPEARSON:=0;
        ERRNONFAT(6,LIGNE1,LIGNE2);
        NBPRESENTS:=0;
        END;
   END;
END;   (* FIN R DE PEARSON *)

FUNCTION RDESPEARMAN(LIGNE1,LIGNE2:INTEGER;VAR PRESENTS:INTEGER):REAL;
VAR I,J,NBPRESENTS,LIEN,LIENS1,LIENS2,DEPART:INTEGER;
    X,Y,SUMD2,SUMX:REAL;
BEGIN
NBPRESENTS:=0;
LIENS1:=0;LIENS2:=0;
FOR I:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[I];
      Y:=MAT2@[I];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            MAT3@[NBPRESENTS]:=X;
            MAT2@[NBPRESENTS]:=Y;
            END;
      END;
PRESENTS:=NBPRESENTS;
IF NBPRESENTS < 1 THEN
      BEGIN
      RDESPEARMAN:=0;
      ERRNONFAT(2,LIGNE1,LIGNE2);
      END
ELSE
      BEGIN
      SHELLSORT(MAT3@,MAT2@,1,NBPRESENTS);
      J:=1;X:=MAT3@[1];LIEN:=1;SUMX:=1;
      DEPART:=1;
      FOR I:=2 TO NBPRESENTS DO
            BEGIN
            IF MAT3@[I]<>X THEN
                  BEGIN
                  LIENS1:=LIENS1+LIEN*(LIEN*LIEN-1);
                  Y:=SUMX/LIEN;
                  FOR J:=I-1 DOWNTO DEPART DO MAT3@[J]:=Y;
                  LIEN:=1;
                  DEPART:=I;
                  SUMX:=I;
                  END
            ELSE
                  BEGIN
                  LIEN:=LIEN+1;
                  SUMX:=SUMX+I;
                  END;
            X:=MAT3@[I];
            END;
      LIENS1:=LIENS1+LIEN*(LIEN*LIEN-1);
      Y:=SUMX/LIEN;
      FOR J:=NBPRESENTS DOWNTO DEPART DO MAT3@[J]:=Y;
      SHELLSORT(MAT2@,MAT3@,1,NBPRESENTS);
      LIEN:=1;
      X:=MAT2@[1];SUMX:=1;DEPART:=1;
      SUMD2:=0;
      FOR I:=2 TO NBPRESENTS DO
            BEGIN
            IF X<>MAT2@[I] THEN
                  BEGIN
                  LIENS2:=LIENS2+LIEN*(LIEN*LIEN-1);
                  Y:=SUMX/LIEN;
                  FOR J:=I-1 DOWNTO DEPART DO
                  SUMD2:=SUMD2+SQR(MAT3@[J]-Y);
                  DEPART:=I;
                  SUMX:=I;
                  LIEN:=1;
                  END
            ELSE
                  BEGIN
                  LIEN:=LIEN+1;
                  SUMX:=SUMX+I;
                  END;
            X:=MAT2@[I];
            END;
      LIENS2:=LIENS2+LIEN*(LIEN*LIEN-1);
      Y:=SUMX/LIEN;
      FOR J:=NBPRESENTS DOWNTO DEPART DO SUMD2:=SUMD2+SQR(MAT3@[J]-Y);
      NBPRESENTS:=NBPRESENTS*(NBPRESENTS*NBPRESENTS-1);
      X:=(NBPRESENTS-LIENS1)/12;
      Y:=(NBPRESENTS-LIENS2)/12;
      IF ((X<>0)AND(Y<>0)) THEN
         RDESPEARMAN:=(X+Y-SUMD2)/(2*SQRT(X*Y))
      ELSE
            BEGIN
            ERRNONFAT(6,LIGNE1,LIGNE2);
            RDESPEARMAN:=0;
            END;
      END;
END;  (* FIN R DE SPEARMAN *)

FUNCTION D01(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            XX:=XX+SQR(X-Y);
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      D01:=MAXREEL;
      END
ELSE D01:=SQRT(XX);
END;  (* FIN D01 *)

FUNCTION D02(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            XX:=XX+SQR(X-Y);
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      D02:=MAXREEL;
      END
ELSE D02:=SQRT(XX/NBPRESENTS);
END;  (* FIN D02 *)

FUNCTION D03(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,X2,Y,Y2,XY:REAL;
BEGIN
NBPRESENTS:=0;X:=0;
X2:=0;Y:=0;Y2:=0;XY:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            X2:=X2+X*X;
            Y2:=Y2+Y*Y;
            XY:=XY+X*Y;
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      D03:=1;
      ERRNONFAT(2,LIGNE1,LIGNE2);
      END
ELSE D03:=SQRT(2*(1-XY/SQRT(X2*Y2)));
END;  (* FIN D03 *)

FUNCTION D04(LIGNE1,LIGNE2:INTEGER):REAL;
VAR X:REAL;
BEGIN
X:=D03(LIGNE1,LIGNE2);
X:=1-X*X/2;
D04:=ARCTAN(SQRT(1-X*X)/X);
END;  (* FIN D04 *)

PROCEDURE D05(LONGUEUR:INTEGER);
VAR I,J,K,L,CARD1,CARD2,LGNBD,DF1,DF2,P1,P2,LAST,ADDR,GROUPE1,GROUPE2,
VGROUPE1,VGROUPE2,
ABSENTS :INTEGER;
    X,Y,Z:REAL;
    MAT1,MAT2:PTRMATREEL;
    DONNEE,MOYENNE:PTRMAT;
    CARD:PTRINT;
    ERROR:BOOLEAN;
BEGIN  (* THERE WILL EVENTUALLY BE AN OPTION TO REPLACE MISSING VAL. *)
RESET(ENTREEC);
REWRITE(BIN);
FOR I:=1 TO NBGROUPES DO
      BEGIN
      CARD1:=MATINT1@[I];
      IF IDENTLIGNE THEN ENTREIDENT;
      FOR J:=1 TO CARD1 DO
            BEGIN
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  READ(ENTREEC,X);
                  BIN@:=X;
                  PUT(BIN);
                  END;
            IF ((IDENTLIGNE)AND(J<>CARD1)) THEN
                  BEGIN
                  READLN(ENTREEC);
                  FOR L:=1 TO NBCHAR DO READ(ENTREEC,IDENTIFICATEUR[L]);
                  END;
            END;
      END;
IF IDENTLIGNE THEN
      BEGIN
      FOR I:=1 TO NBGROUPES DO ECRITCHAR(MATID@[I],SORTIE);
      IF PROBABILITE THEN FOR I:=1 TO NBGROUPES DO
      ECRITCHAR(MATID@[I],PROBAB);
      DISPOSE(MATID);
      END;
RESET(BIN);
REWRITE(TEMP1);
NEW(CARD);
NEW(MOYENNE);
FOR I:=1 TO NBGROUPES DO
      BEGIN
      CARD1:=MATINT1@[I];
      FOR J:=1 TO NBDESC DO
            BEGIN
            MOYENNE@[J]:=0;
            CARD@[J]:=0;
            END;
      FOR J:=1 TO CARD1 DO
            BEGIN
            CARD2:=0;
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  X:=BIN@;GET(BIN);
                  IF X<>ABSENCE THEN
                        BEGIN
                        MOYENNE@[K]:=MOYENNE@[K]+X;
                        CARD@[K]:=CARD@[K]+1;
                        CARD2:=CARD2+1;
                        END;
                  END;
            IF CARD2=0 THEN ERREUR(9,I,J);
            END;
     FOR J:=1 TO NBDESC DO
            BEGIN
            IF CARD@[J]=0 THEN ERREUR(6,I,J)
            ELSE
                  BEGIN
                  TEMP1@:=MOYENNE@[J]/CARD@[J];
                  PUT(TEMP1);
                  END;
            END;
      END;
DISPOSE(CARD);
NEW(MAT1);
NEW(DONNEE);
REWRITE(TEMP);
RESET(TEMP1);
RESET(BIN);
LGNBD:=LONGUEUR+NBDESC;
FOR GROUPE1:=1 TO NBGROUPES DO
      BEGIN
      CARD1:=MATINT1@[GROUPE1];
      FOR J:=1 TO NBDESC DO
            BEGIN
            MOYENNE@[J]:=TEMP1@;
            GET(TEMP1);
            END;
      FOR J:=1 TO LONGUEUR DO MAT1@[J]:=0;
      FOR J:=1 TO CARD1 DO
            BEGIN
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  DONNEE@[K]:=BIN@;
                  GET(BIN);
                  END;
            ADDR:=0;
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  X:=DONNEE@[K];
                  IF X=ABSENCE THEN ADDR:=ADDR+K
                  ELSE
                     BEGIN
                     X:=X-MOYENNE@[K];
                     FOR L:=1 TO K DO
                        BEGIN
                        ADDR:=ADDR+1;
                        Y:=DONNEE@[L];
                        IF Y<>ABSENCE THEN
                             BEGIN
                             MAT1@[ADDR]:=MAT1@[ADDR]+X*(Y-MOYENNE@[L]);
                             END;
                        END;
                     END;
                  END;
            END;
      FOR J:=1 TO LONGUEUR DO
            BEGIN
            TEMP@:=MAT1@[J];
            PUT(TEMP);
            END;
     END;
DISPOSE(DONNEE);
DISPOSE(MOYENNE);
NEW(MAT2);
FOR GROUPE1:=1 TO NBGROUPES-1 DO
      BEGIN
      RESET(TEMP);
      RESET(TEMP1);
      FOR J:=GROUPE1-1 DOWNTO 1 DO
         BEGIN
         FOR K:=1 TO LONGUEUR DO GET(TEMP);
         FOR K:=1 TO NBDESC DO GET(TEMP1);
         END;
      CARD1:=MATINT1@[GROUPE1];
      FOR J:=1 TO LONGUEUR DO
            BEGIN
            MAT1@[J]:=TEMP@;
            GET(TEMP);
            END;
      FOR J:=LONGUEUR+1 TO LGNBD DO
            BEGIN
            MAT1@[J]:=TEMP1@;
            GET(TEMP1);
            END;
      FOR GROUPE2:=GROUPE1+1 TO NBGROUPES DO
            BEGIN
            MAT2@[LGNBD+1]:=0;
            CARD2:=MATINT1@[GROUPE2];
            FOR K:=1 TO LONGUEUR DO
                  BEGIN
                  X:=TEMP@;
                  GET(TEMP);
                  MAT2@[K]:=(MAT1@[K]+X)/(CARD1+CARD2-2);
                  END;
            FOR K:=LONGUEUR+1 TO LGNBD DO
                  BEGIN
                  X:=TEMP1@;
                  GET(TEMP1);
                  MAT2@[K]:=MAT1@[K]-X;
                  END;
            LAST:=0;
            VGROUPE1:=GROUPE1; VGROUPE2:=GROUPE2;
            X:=-LINRES
            (NBDESC+1,1,NBDESC,MAT2@,LAST,ABSENTS,VGROUPE1,VGROUPE2);
            DF1:=NBDESC-ABSENTS;
            DF2:=CARD1+CARD2-DF1-1;
            IF ((DF1 < 1)OR(DF2 < 1)) THEN X:=MAXREEL;
            ECRITREEL(X,SORTIE);
            IF PROBABILITE THEN
                  BEGIN
                  IF X < MAXREEL THEN
                  X:=X*(CARD1*CARD2)*DF2/
                  ((CARD1+CARD2)*(CARD1+CARD2-2)*DF1);
                  X:=FTEST(X,DF1,DF2,ERROR);
                  IF ERROR THEN
                        BEGIN
                        X:=MAXREEL;
                        ERRNONFAT(3,GROUPE1,GROUPE2);
                        END;
                   ECRITREEL(X,PROBAB);
                   END;
            END;
      END;
END;  (* FIN D05 *)


FUNCTION D06(LIGNE1,LIGNE2:INTEGER;PUISSANCE:REAL):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            X:=ABS(X-Y);
            IF X > 0 THEN XX:=XX+EXP(LN(X)*PUISSANCE);
            END;
      END;
IF XX > 0 THEN XX:=EXP(LN(XX)/PUISSANCE);
IF NBPRESENTS < 1 THEN
      BEGIN
      D06:=MAXREEL;
      ERRNONFAT(2,LIGNE1,LIGNE2);
      END
ELSE D06:=XX;
END;  (* FIN D06 *)

FUNCTION D07(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            XX:=XX+ABS(X-Y);
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      D07:=MAXREEL;
      ERRNONFAT(2,LIGNE1,LIGNE2);
      END
ELSE D07:=XX;
END;  (* FIN D07 *)

FUNCTION D08(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            XX:=XX+ABS(X-Y);
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      D08:=MAXREEL;
      END
ELSE D08:=XX/NBPRESENTS;
END;  (* FIN D08 *)

FUNCTION D09(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX,SUMX,SUMY:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;SUMX:=0;SUMY:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            SUMX:=SUMX+X;
            SUMY:=SUMY+Y;
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      D09:=2;
      ERRNONFAT(2,LIGNE1,LIGNE2);
      END
ELSE
      BEGIN
      IF ((SUMX=0)OR(SUMY=0)) THEN
            BEGIN
            ERREUR(3,LIGNE1,LIGNE2);
            END
      ELSE
            BEGIN
            XX:=0;
            FOR COLONNE:=1 TO NBDESC DO
               BEGIN
               X:=MAT1@[COLONNE];
               Y:=MAT2@[COLONNE];
               IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
                  XX:=XX+ABS(X/SUMX-Y/SUMY);
               END;
               D09:=XX/2;
            END;
      END;
END;  (* FIN D09 *)

FUNCTION D10(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF (((X<>ABSENCE)AND(Y<>ABSENCE))AND(X+Y<>0)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            XX:=XX+ABS(X-Y)/(X+Y);
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      D10:=MAXREEL;
      END
ELSE D10:=XX;
END;  (* FIN D10 *)

FUNCTION D11(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
     X,Y,XX:REAL;
BEGIN
NBPRESENTS:=0;XX:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF (((X<>ABSENCE)AND(Y<>ABSENCE))AND(X+Y<>0)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            XX:=XX+SQR((X-Y)/(X+Y));
            END;
      END;
IF NBPRESENTS < 1 THEN
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      D11:=MAXREEL;
      END
ELSE D11:=SQRT(XX/NBPRESENTS);
END;  (* FIN D11 *)

PROCEDURE D12(VAR MOYENNE,SIGMA2:MAT0);
VAR I,J,K,CARDINALITE:INTEGER;
    X,Y,SUM:REAL;
    PRESENCE:PTRINT;
BEGIN
REWRITE(TEMP);
NEW(PRESENCE);
FOR I:=1 TO NBGROUPES DO
      BEGIN
      CARDINALITE:=MATINT1@[I];
      FOR J:=1 TO NBDESC DO
            BEGIN
            MOYENNE[J]:=0;
            SIGMA2[J]:=0;
            PRESENCE@[J]:=0;
            END;
      IF IDENTLIGNE THEN ENTREIDENT;
      FOR J:=1 TO CARDINALITE DO
            BEGIN
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  READ(ENTREEC,X);
                  IF X<>ABSENCE THEN
                        BEGIN
                        MOYENNE[K]:=MOYENNE[K]+X;
                        SIGMA2 [K]:=SIGMA2 [K]+X*X;
                        PRESENCE@[K]:=PRESENCE@[K]+1;
                        END;
                  END;
            IF ((IDENTLIGNE)AND(J<>CARDINALITE)) THEN
                  BEGIN
                  READLN(ENTREEC);
                  FOR K:=1 TO NBCHAR DO READ(ENTREEC,IDENTIFICATEUR[K]);
                  END;
            END;
      FOR J:=1 TO NBDESC DO
            BEGIN
            IF PRESENCE@[J] < 2 THEN ERREUR(6,I,J)
            ELSE
                  BEGIN
                  Y:=PRESENCE@[J];
                  X:=MOYENNE[J]/Y;
                  TEMP@:=X;PUT(TEMP);
                  X:=(SIGMA2[J]-X*X*Y)/Y/(Y-1);
                  IF X<=0 THEN ERREUR(6,I,J)
                  ELSE
                        BEGIN
                        TEMP@:=X;PUT(TEMP);
                        END;
                  END;
            END;
      END;
DISPOSE(PRESENCE);
IF IDENTLIGNE THEN
      BEGIN
      FOR I:=1 TO NBGROUPES DO ECRITCHAR(MATID@[I],SORTIE);
      DISPOSE(MATID);
      END;
FOR I:=1 TO NBGROUPES-1 DO
      BEGIN
      RESET(TEMP);
      FOR J:=1 TO I-1 DO
         FOR K:=1 TO NBDESC DO BEGIN GET(TEMP);GET(TEMP);END;
      FOR J:=1 TO NBDESC DO
            BEGIN
            MOYENNE[J]:=TEMP@;GET(TEMP);
            SIGMA2[J]:=TEMP@;GET(TEMP);
            END;
      SUM:=0;
      FOR J:=I+1 TO NBGROUPES DO
            BEGIN
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  X:=TEMP@;GET(TEMP);
                  Y:=TEMP@;GET(TEMP);
                  SUM:=SUM+SQR(MOYENNE[K]-X)/(SIGMA2[K]+Y);
                  END;
            ECRITREEL(SQRT(SUM/NBDESC)-2/NBDESC,SORTIE);
            END;
      END;
END;   (* FIN  D12 *)

FUNCTION S00(A,B,C,D,N:REAL):REAL;
BEGIN
S00:=A/(A+B+C);
END;  (* FIN S00 *)

FUNCTION S15(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
    X,Y,XX,SUMWI,WI:REAL;
BEGIN
NBPRESENTS:=0;
XX:=0;SUMWI:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            WI:=MAT4@[COLONNE];
            SUMWI:=SUMWI+WI;
            IF MULTCLASS@[COLONNE] THEN
                  BEGIN
                  IF X = Y THEN XX:=XX+WI;
                  END
            ELSE XX:=XX+(1-ABS(X-Y)/MAT3@[COLONNE])*WI;
            END;
      END;
IF NBPRESENTS >= 1 THEN
      S15:=XX/SUMWI
ELSE
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      S15:=0;
      END;
END;  (* FIN S15 *)

FUNCTION S16(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS,NEXT,ORDRE,NBCALCULS,V1,V2,J,L:INTEGER;
    X,Y,K,XX,SUMWI,WI:REAL;
    PT:LINK;
BEGIN
NBPRESENTS:=0;
XX:=0;SUMWI:=0;
PT:=PROCHAIN;
NEXT:=PT@.INT1;
ORDRE:=PT@.INT2;
NBCALCULS:=ORDRE*(ORDRE-1) DIV 2;
RESET(TEMP);
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            WI:=MAT4@[COLONNE];
            SUMWI:=SUMWI+WI;
            IF NEXT<>COLONNE THEN
                  BEGIN
                  X:=ABS(X-Y);
                  K:=MAT3@[COLONNE];
                  IF X <= K THEN XX:=XX+(2*(K+1-X)/(2*(K+1)+X*K))*WI;
                  END
            ELSE
                  BEGIN
                  V1:=TRUNC(X+0.5);
                  V2:=TRUNC(Y+0.5);
                  IF V2 > V1 THEN
                        BEGIN
                        J:=V2;
                        V2:=V1;
                        V1:=J;
                        END;
                  IF V1 > ORDRE THEN ERREUR(13,LIGNE1,LIGNE2);
                  L:=1;
                  IF ((V1=0)OR(V2=0)) THEN ERREUR(14,LIGNE1,LIGNE2);
                  IF V1=V2 THEN X:=1
                  ELSE
                        BEGIN
                        L:=(V1-1)*(V1-2)DIV 2 +V2;
                        FOR J:=2 TO L DO GET(TEMP);
                        X:=TEMP@;
                        END;
                  FOR J:=L TO NBCALCULS DO GET(TEMP);
                  PT:=PT@.LIEN;
                  NEXT:=PT@.INT1;
                  ORDRE:=PT@.INT2;
                  NBCALCULS:=ORDRE*(ORDRE-1) DIV 2;
                  XX:=XX+X*WI;
                  END;
            END
      ELSE IF NEXT=COLONNE THEN
                  BEGIN
                  FOR J:=1 TO NBCALCULS DO GET(TEMP);
                  PT:=PT@.LIEN;
                  NEXT:=PT@.INT1;
                  ORDRE:=PT@.INT2;
                  NBCALCULS:=ORDRE*(ORDRE-1) DIV 2;
                  END;
      END;
IF NBPRESENTS >= 1 THEN
      S16:=XX/SUMWI
ELSE
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      S16:=0;
      END;
END;  (* FIN S16 *)

PROCEDURE S17S18(LIGNE1,LIGNE2:INTEGER;VAR A,B,W:REAL);
VAR COLONNE,NBPRESENTS:INTEGER;
    X,Y:REAL;
BEGIN
A:=0;B:=0;W:=0;
NBPRESENTS:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            A:=A+X;
            B:=B+Y;
            IF X < Y THEN W:=W+X
            ELSE W:=W+Y;
            END;
      END;
END;    (* FIN S17S18 *)

FUNCTION S19(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
    X,Y,XX,SUMWI,WI:REAL;
BEGIN
NBPRESENTS:=0;
XX:=0;SUMWI:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF (((X<>ABSENCE)AND(Y<>ABSENCE))AND(X+Y<>0)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            WI:=MAT4@[COLONNE];
            SUMWI:=SUMWI+WI;
            XX:=XX+(1-ABS(X-Y)/MAT3@[COLONNE])*WI;
            END;
      END;
IF NBPRESENTS >= 1 THEN
      S19:=XX/SUMWI
ELSE
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      S19:=0;
      END;
END;  (* FIN S19 *)

FUNCTION S20(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS,NEXT,ORDRE,NBCALCULS,V1,V2,J,L:INTEGER;
    X,Y,K,XX,SUMWI,WI:REAL;
    PT:LINK;
BEGIN
NBPRESENTS:=0;
XX:=0;SUMWI:=0;
PT:=PROCHAIN;
NEXT:=PT@.INT1;
ORDRE:=PT@.INT2;
NBCALCULS:=ORDRE*(ORDRE-1) DIV 2;
RESET(TEMP);
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF (((X<>ABSENCE)AND(Y<>ABSENCE))AND(X*Y<>0)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            WI:=MAT4@[COLONNE];
            SUMWI:=SUMWI+WI;
            IF NEXT<>COLONNE THEN
                  BEGIN
                  X:=ABS(X-Y);
                  K:=MAT3@[COLONNE];
                  IF X <= K THEN XX:=XX+(2*(K+1-X)/(2*(K+1)+X*K))*WI;
                  END
            ELSE
                  BEGIN
                  V1:=TRUNC(X+0.5);
                  V2:=TRUNC(Y+0.5);
                  IF V2 > V1 THEN
                        BEGIN
                        J:=V2;
                        V2:=V1;
                        V1:=J;
                        END;
                  IF V1 > ORDRE THEN ERREUR(13,LIGNE1,LIGNE2);
                  L:=1;
                  IF (V1 * V2=0) THEN X:=0
                  ELSE
                        BEGIN
                        IF V1=V2 THEN X:=1
                        ELSE
                              BEGIN
                              L:=(V1-1)*(V1-2)DIV 2 +V2;
                              FOR J:=2 TO L DO GET(TEMP);
                              X:=TEMP@;
                              END;
                        END;
                  FOR J:=L TO NBCALCULS DO GET(TEMP);
                  PT:=PT@.LIEN;
                  NEXT:=PT@.INT1;
                  ORDRE:=PT@.INT2;
                  NBCALCULS:=ORDRE*(ORDRE-1) DIV 2;
                  XX:=XX+X*WI;
                  END;
            END
      ELSE IF NEXT=COLONNE THEN
                  BEGIN
                  FOR J:=1 TO NBCALCULS DO GET(TEMP);
                  PT:=PT@.LIEN;
                  NEXT:=PT@.INT1;
                  ORDRE:=PT@.INT2;
                  NBCALCULS:=ORDRE*(ORDRE-1) DIV 2;
                  END;
      END;
IF NBPRESENTS >= 1 THEN
      S20:=XX/SUMWI
ELSE
      BEGIN
      ERRNONFAT(2,LIGNE1,LIGNE2);
      S20:=0;
      END;
END;  (* FIN S20 *)

FUNCTION S21(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
    X,Y,SUM,SUMX,SUMY:REAL;
BEGIN
SUMX:=0;SUMY:=0;
NBPRESENTS:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            NBPRESENTS:=NBPRESENTS+1;
            SUMX:=SUMX+X;SUMY:=SUMY+Y;
            END;
      END;
SUM:=0;
IF NBPRESENTS<1 THEN ERRNONFAT(2,LIGNE1,LIGNE2)
ELSE
   BEGIN
   IF ((SUMX=0)OR(SUMY=0)) THEN ERRNONFAT(4,LIGNE1,LIGNE2)
   ELSE FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF ((X<>ABSENCE)AND(Y<>ABSENCE)) THEN
            BEGIN
            SUM:=SUM+SQR(X/SUMX-Y/SUMY)/MAT3@[COLONNE];
            END;
      END;
   END;
S21:=1-SQRT(SUM);
END;  (* FIN S21 *)

FUNCTION S22(LIGNE1,LIGNE2:INTEGER):REAL;
VAR COLONNE,NBPRESENTS:INTEGER;
    X,Y,SUM,SUMX,SUMY,XPLUSY,SUM2:REAL;
BEGIN
SUM:=0;SUM2:=0;SUMX:=0;SUMY:=0;
NBPRESENTS:=0;
FOR COLONNE:=1 TO NBDESC DO
      BEGIN
      X:=MAT1@[COLONNE];
      Y:=MAT2@[COLONNE];
      IF (((X<>ABSENCE)AND(Y<>ABSENCE))AND(X+Y<>0)) THEN
            BEGIN
            XPLUSY:=X+Y;
            SUMX:=SUMX+X;
            SUMY:=SUMY+Y;
            IF WILKS THEN SUM:=SUM+X*LN(X)+Y*LN(Y)-XPLUSY*LN(XPLUSY)
            ELSE
                  BEGIN
                  SUM:=SUM+X*X/XPLUSY;
                  SUM2:=SUM2+Y*Y/XPLUSY;
                  END;
            NBPRESENTS:=NBPRESENTS+1;
            END;
      END;
IF NBPRESENTS<2 THEN
      BEGIN
      ERRNONFAT(3,LIGNE1,LIGNE2);
      S22:=0;
      END
ELSE
      BEGIN
      XPLUSY:=SUMX+SUMY;
      IF WILKS THEN
      SUM:=2*(SUM+XPLUSY*LN(XPLUSY)-SUMX*LN(SUMX)-SUMY*LN(SUMY))
      ELSE SUM:=(SUM/SUMX+SUM2/SUMY-1)*(SUMX+SUMY);
      WRONG:=FALSE;
      SUM:=1-CHIPROB(SUM,NBPRESENTS-1,FALSE,WRONG);
      IF WRONG THEN
            BEGIN
            ERRNONFAT(3,LIGNE1,LIGNE2);
            S22:=0;
            END
      ELSE S22:=SUM;
      END;
END;   (* FIN S22 *)

PROCEDURE S23;
VAR I,J,K,L,NBCALCULS,DF:INTEGER;
   MATREEL1,MATREEL2,MATREEL3:PTRMATREEL;
   NORME,MINIMUM,X,Y:REAL;
   ERROR:BOOLEAN;
BEGIN
RESET(TEMP);
NEW(MAT1);
NEW(MATREEL1);
NEW(MATREEL2);
NEW(MATREEL3);
NBCALCULS:=NOBJ*(NOBJ-1) DIV 2;
DF:=NBDESC*2;
FOR I:=1 TO NBCALCULS DO MATREEL1@[I]:=0;
FOR I:=1 TO NBDESC DO
      BEGIN
      MINIMUM:=TEMP@;
      NORME:=MINIMUM;
      FOR J:=1 TO NOBJ DO
            BEGIN
            X:=TEMP@;
            IF X>NORME THEN NORME:=X;
            IF X<MINIMUM THEN MINIMUM:=X;
            MAT1@[J]:=X;
            GET(TEMP);
            END;
      NORME:=NORME-MINIMUM;
      IF NORME=0 THEN
            BEGIN
            ERRNONFAT(7,I,0);
            DF:=DF-2;
            END
      ELSE
            BEGIN
            L:=0;
            FOR J:=1 TO NOBJ DO
                  BEGIN
                  X:=MAT1@[J];
                  FOR K:=J+1 TO NOBJ DO
                        BEGIN
                        Y:=MAT1@[K];
                        L:=L+1;
                        IF X+Y <> 0 THEN
                              BEGIN
                              IF OPTION=1 THEN
                              MATREEL2@[L]:=1-ABS(X-Y)/NORME
                              ELSE
                                    BEGIN
                                    IF X >Y THEN MATREEL2@[L]:=Y/(X+Y)
                                    ELSE MATREEL2@[L]:=X/(X+Y);
                                    END;
                              END
                        ELSE MATREEL2@[L]:=0;
                        END;
                  END;
            (* CALCULE ORDRE *)
            FOR J:=1 TO NBCALCULS DO MATREEL3@[J]:=NBCALCULS;
            FOR J:=NBCALCULS DOWNTO 2 DO
                  BEGIN
                  X:=MATREEL2@[J];
                  FOR K:=J-1 DOWNTO 1 DO
                        BEGIN
                        Y:=MATREEL2@[K];
                        IF X < Y THEN MATREEL3@[K]:=MATREEL3@[K]-1
                        ELSE IF X > Y THEN
                        MATREEL3@[J]:=MATREEL3@[J]-1;
                        END;
                  END;
            FOR J:=1 TO NBCALCULS DO
            MATREEL1@[J]:=MATREEL1@[J]+LN(MATREEL3@[J]);
            END;
      END;
IF DF<=0 THEN ERREUR(11,0,0);
X:=DF*LN(NBCALCULS);
FOR I:=1 TO NBCALCULS DO
   ECRITREEL(1-CHIPROB(X-2*MATREEL1@[I],DF,FALSE,ERROR),SORTIE);
END;  (* FIN S23 (GOODAL) *)

PROCEDURE FN(FONCTION,LIGNE1,LIGNE2:INTEGER);
VAR X,PROB,A,B,C,P,W,P2B:REAL;
   J,PRESENTS,DF:INTEGER;
   ERROR:BOOLEAN;
   PROCEDURE TESTT;
      BEGIN
      DF:=PRESENTS-2;
      IF DF > 0 THEN
            BEGIN
            PROB:=ABS(X);
            IF PROB >=1-EPSILON THEN PROB:=1-EPSILON;
            PROB:=PROB*SQRT(DF)/SQRT(1-PROB*PROB);
            END;
      PROB:=1-FTEST(PROB*PROB,1,DF,ERROR);
      IF ERROR THEN BEGIN ERRNONFAT(3,LIGNE1,LIGNE2);PROB:=0;END;
      END;   (* FIN TESTT *)
BEGIN
CASE FONCTION OF
      15:X:=S15(LIGNE1,LIGNE2);
      16:X:=S16(LIGNE1,LIGNE2);
      17:BEGIN
         X:=0;
         S17S18(LIGNE1,LIGNE2,A,B,W);
         IF (A+B)=0  THEN ERRNONFAT(4,LIGNE1,LIGNE2)
         ELSE X:=2*W/(A+B);
         END;
      18:BEGIN
         X:=0;
         S17S18(LIGNE1,LIGNE2,A,B,W);
         IF ((A=0)OR(B=0)) THEN ERRNONFAT(4,LIGNE1,LIGNE2)
         ELSE X:=(W/A+W/B)/2;
         END;
      19:X:=S19(LIGNE1,LIGNE2);
      20:X:=S20(LIGNE1,LIGNE2);
      21:X:=S21(LIGNE1,LIGNE2);
      22:X:=S22(LIGNE1,LIGNE2);
      26:X:=D01(LIGNE1,LIGNE2);
      27:X:=D02(LIGNE1,LIGNE2);
      28:X:=D03(LIGNE1,LIGNE2);
      29:X:=D04(LIGNE1,LIGNE2);
      31:X:=D06(LIGNE1,LIGNE2,PUISSANCE);
      32:X:=D07(LIGNE1,LIGNE2);
      33:X:=D08(LIGNE1,LIGNE2);
      34:X:=D09(LIGNE1,LIGNE2);
      35:X:=D10(LIGNE1,LIGNE2);
      36:X:=D11(LIGNE1,LIGNE2);
      39:BEGIN
         S17S18(LIGNE1,LIGNE2,A,B,W);
         A:=A+B;
         IF A > 0 THEN X:=1-2*W/A
         ELSE
            BEGIN
            ERRNONFAT(2,LIGNE1,LIGNE2);
            X:=0;
            END;
         END;
      50:BEGIN
         X:=TAU(LIGNE1,LIGNE2,PRESENTS);
         IF PROBABILITE THEN
            BEGIN
            IF PRESENTS > 1 THEN
             PROB:=ZTEST(ABS(X)*SQRT(9*PRESENTS*(PRESENTS-1)/
                (4*PRESENTS+10))
                     -SQRT(18/(PRESENTS*(PRESENTS-1)*(2*PRESENTS+5))))
            ELSE BEGIN ERRNONFAT(3,LIGNE1,LIGNE2);PROB:=0;END;
            END;
         END;
      51:BEGIN
         X:=RDEPEARSON(LIGNE1,LIGNE2,PRESENTS);
         IF PROBABILITE THEN TESTT;
         END;
      52:BEGIN
         X:=RDESPEARMAN(LIGNE1,LIGNE2,PRESENTS);
         IF PROBABILITE THEN TESTT;
         END;
      53,54,55,56,57,58:BEGIN
            ENTROPIE(A,B,C,P,DF,LIGNE1,LIGNE2);
            P2B:=2*P*B;
            X:=0;
            IF ((PROBABILITE) OR (FONCTION=53)) THEN
                  BEGIN
                  PROB:=CHIPROB(P2B,DF,FALSE,ERROR);
                  IF ERROR THEN BEGIN
                  ERRNONFAT(3,LIGNE1,LIGNE2);PROB:=0;END;
                  END;
            IF (A+B+C)>0 THEN CASE FONCTION OF
                 53:X:=P2B;
                 54:BEGIN
                    IF DF>0 THEN X:=SQRT(P2B/P/SQRT(DF));
                    END;
                 55:X:=B/(A+B+C);
                 56:X:=SQRT(1-SQR((A+C)/(A+B+C)));
                 57:X:=B/(A+2*B+C);
                 58:X:=(A+C)/(A+B+C);
                 END
            ELSE ERRNONFAT(4,LIGNE1,LIGNE2);
            END;
      59:BEGIN                                                 (* Nei *)
         X:=RDEPEARSON(LIGNE1,LIGNE2,PRESENTS);                (* Nei *)
         END;                                                  (* Nei *)
      END;
ECRITREEL(X,SORTIE);
IF PROBABILITE THEN ECRITREEL(PROB,PROBAB);
END;   (* FN *)

PROCEDURE NUMEROTE(VAR FONCTION:INTEGER);
VAR CAR:CHAR;
    I:INTEGER;
LABEL 888;
BEGIN
888: IF LANG=1 THEN BEGIN
WRITELN(' QUELLE FONCTION DESIREZ-VOUS CALCULER ?                   ');
WRITELN(' Similarites   : s01  a  s26, ou  Nei      ');        (* Nei *)
WRITELN(' Distances     : d01  a  d14           ');
WRITELN(' Mode R:    rp = r de Pearson                              ');
WRITELN('            rs = r de Spearman                             ');
WRITELN('            tau= Tau de Kendall                            ');
WRITELN('            khi= Khi-carre (statistique G)                 ');
WRITELN('            ht = Coefficient de contingence de Tschuproff  ');
WRITELN('            hs0= Information reciproque         S=B/(A+B+C)');
WRITELN('            hs1= Coherence de Rajski     S''=SQRT(1-(hd)**2)');
WRITELN('            hs2= Coeff. symetr. d''incertitude S"=B/(A+2B+C)');
WRITELN('            hd = Metrique de Rajski        D =(A+C)/(A+B+C)');
END ELSE BEGIN
WRITELN(' WHAT RESEMBLANCE FUNCTION DO YOU WANT TO COMPUTE ?       ');
WRITELN(' Similarities  : s01 to s26, Nei       ');            (* Nei *)
WRITELN(' Distances     : d01 to d14            ');
WRITELN(' R-mode:    rp = Pearson''s r                             ');
WRITELN('            rs = Spearman''s r                            ');
WRITELN('            tau= Kendall''s tau                           ');
WRITELN('            chi= Chi-square (G statistic)                 ');
WRITELN('            ht = Tschuproff''s contingency coefficient     ');
WRITELN('            hs0= Reciprocal information        S=B/(A+B+C)');
WRITELN('            hs1= Rajski''s coherence     S''=SQRT(1-(hd)**2)');
WRITELN('            hs2= Symmetric uncertainty coeff.S"=B/(A+2B+C)');
WRITELN('            hd = Rajski''s metric          D =(A+C)/(A+B+C)');
END;
WRITELN('      ');
WHILE INPUT@=' ' DO GET(INPUT);
FOR I:=1 TO NBCHAR DO FONC[I]:=' ';
I:=2;
WHILE ((NOT(EOLN(INPUT)))AND(I<=4)) DO
      BEGIN
      FONC[I]:=INPUT@;GET(INPUT);
      I:=I+1;
      END;
(* WRITELN(FONC[2],FONC[3],FONC[4]);                          DEBUG *)
QUANTITATIF:=TRUE;
GROUPE:=FALSE;
CAR:=FONC[2];
CASE CAR OF
  'S','s':BEGIN
          CAR:=FONC[3];
          IF NOT((CAR IN['0'..'2'])AND(FONC[4] IN ['0'..'9'])) THEN
             BEGIN ERRNONFAT(8,0,0); GOTO 888; END
          ELSE FONCTION:=10*(ORD(CAR)-ORD('0'))+ORD(FONC[4])-ORD('0');
          IF FONCTION>26 THEN BEGIN ERRNONFAT(8,0,0); GOTO 888; END;
          IF FONCTION IN[1..14,24,25,26] THEN QUANTITATIF:=FALSE;
          END;
  'D','d':BEGIN
          GROUPE:=FALSE;
          CAR:=FONC[3];
          IF NOT((CAR IN['0'..'1'])AND(FONC[4] IN['0'..'9'])) THEN
             BEGIN ERRNONFAT(8,0,0); GOTO 888; END
          ELSE FONCTION:=10*(ORD(CAR)-ORD('0'))+ORD(FONC[4])-ORD('0');
          IF FONCTION=13 THEN QUANTITATIF:=FALSE
          ELSE IF FONCTION IN [5,12] THEN GROUPE:=TRUE;
          IF FONCTION>14 THEN BEGIN ERRNONFAT(8,0,0); GOTO 888; END
          ELSE FONCTION:=FONCTION+25;
          END;
  'T','t':BEGIN
          FONCTION:=50;   (* TAU DE KENDALL *)
          END;
  'R','r':BEGIN
          IF FONC[3]='p' THEN FONCTION:=51
          ELSE IF FONC[3]='s' THEN FONCTION:=52;
          END;
  'N','n':BEGIN                                                (* Nei *)
          FONCTION:=59;                                        (* Nei *)
          IF LANG=1 THEN WRITELN                               (* Nei *)
('      La SIMILARITE genetique de Nei est bornee [0, 1]')     (* Nei *)
          ELSE WRITELN                                         (* Nei *)
('      Nei''s genetic SIMILARITY is bounded between 0 and 1');(* Nei *)
          END;                                                 (* Nei *)
  'K','k','C','c':FONCTION:=53;
  'H','h':BEGIN
          CAR:=FONC[3];
          IF CAR IN['T','t'] THEN FONCTION:=54
          ELSE
                BEGIN
                IF CAR IN['S','s'] THEN
                      BEGIN
                      CAR:=FONC[4];
                      CASE CAR OF
                          '0':FONCTION:=55;
                          '1':FONCTION:=56;
                          '2':FONCTION:=57;
                OTHERWISE BEGIN ERRNONFAT(8,0,0); GOTO 888; END;
                          END;
                      END
                ELSE
                     BEGIN
                     IF CAR IN['D','d'] THEN FONCTION:=58
                     ELSE BEGIN ERRNONFAT(8,0,0); GOTO 888; END;
                     END;
                END;
          END;
      OTHERWISE
          BEGIN
          ERRNONFAT(8,0,0);
          GOTO 888;
          END;
      END;
END;   (* FIN NUMEROTE *)

PROCEDURE PREPABS;
VAR I,J,K,L:INTEGER;
    X,SEUIL:REAL;
    ENSEMBLE,ENSVIDE:ENS;
BEGIN
IF NBDESC>MAXBITS THEN ERREUR(7,0,0);
NBMOT:=NBDESC DIV NBBITS;
IF LANG=1 THEN BEGIN WRITELN
(' A PARTIR DE QUELLE VALEUR L''INFORMATION DOIT-ELLE ETRE CODEE 1 ?');
WRITELN(' (EN-DESSOUS DE CETTE VALEUR, LE CODE SERA 0) ');
END ELSE BEGIN
WRITELN(' WHAT IS THE THRESHOLD VALUE FOR INFORMATION CODED 1 ? ');
WRITELN(' (SMALLER THAN THIS VALUE, THE CODE WILL BE 0) ');END;
READLN(SEUIL);
(* WRITELN(SEUIL);                                            DEBUG *)
REWRITE(BINTEMP);
FOR I:=1 TO NOBJ  DO
      BEGIN
      ENSEMBLE:=[];
      ENSVIDE :=[];
      K:=0;L:=1;
      IF IDENTLIGNE THEN ENTREIDENT;
      FOR J:=1 TO NBDESC DO
            BEGIN
            READ(ENTREEC,X);
            IF X = ABSENCE THEN ENSVIDE:=ENSVIDE+[L]
            ELSE IF X >= SEUIL THEN ENSEMBLE:=ENSEMBLE+[L];
            L:=L+1;
            IF L > NBBITS1 THEN
                  BEGIN
                  K:=K+1;
                  L:=0;
                  BINTEMP@:=ENSEMBLE;PUT(BINTEMP);
                  BINTEMP@:=ENSVIDE ;PUT(BINTEMP);
                  ENSEMBLE:=[];ENSVIDE:=[];
                  END;
            END;
      IF L > 0 THEN
            BEGIN
            BINTEMP@:=ENSEMBLE;
            PUT(BINTEMP);
            BINTEMP@:=ENSVIDE;
            PUT(BINTEMP);
            END;
      END;
END;  (* FIN PREPARE PRESENCE ABSENCE *)

PROCEDURE LECTURE(VAR MAT3:MAT0;VAL:INTEGER);
VAR I:INTEGER;
BEGIN
I:=0;
WHILE I<VAL DO
      BEGIN
      I:=I+1;
      READ(MAT3[I]);
(* WRITE(MAT3[I]);                                           DEBUG *)
      END;
(* WRITELN;                                                  DEBUG *)
END;   (* FIN LECTURE *)

PROCEDURE SOMME(VAR MAT:MAT0);
VAR I,J:INTEGER;
    X:REAL;
BEGIN
RESET(BIN);
FOR I:=1 TO NBDESC DO MAT[I]:=0;
FOR I:=1 TO NOBJ DO
   FOR J:=1 TO NBDESC DO
      BEGIN
      X:=BIN@;GET(BIN);
      IF X<>ABSENCE THEN MAT[J]:=MAT[J]+X;
      END;
FOR I:=1 TO NBDESC DO IF MAT[I]=0 THEN ERREUR(2,I,0);
END;   (* FIN SOMME *)

PROCEDURE PREPECART(VAR MAT:MAT0);
BEGIN
IF LANG=1 THEN BEGIN
WRITELN(' LES ECARTS MAXIMA DES VARIABLES (R[i]) ');
WRITELN(' DOIVENT-ILS ETRE CALCULES A PARTIR DES DONNEES? (o ou n)');END
ELSE WRITELN(' SHOULD THE VARIABLE',
                 ' RANGES BE COMPUTED FROM THE DATA SET? (y or n) ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IF INPUT@ IN ['N','n'] THEN
   BEGIN READLN;
(* WRITELN(' No ');                                             DEBUG *)
IF LANG=1 THEN
WRITELN(' INSCRIVEZ LES DIFFERENTS ECARTS R[i] IMPOSES ')
ELSE WRITELN(' TYPE IN THE RANGES FOR ALL VARIABLES    ');
   LECTURE(MAT,NBDESC);
   END
ELSE BEGIN READLN;
   ECART(MAT);
(* WRITELN(' Yes ');                                            DEBUG *)
   END;
END;  (* PREPARE ECART *)

PROCEDURE PREPWI(VAR MAT:MAT0);
VAR I:INTEGER;
BEGIN
IF LANG=1 THEN
WRITELN (' LES POIDS W[i] DOIVENT-ILS ETRE SIMPLEMENT 0 OU 1? (o ou n)')
ELSE
WRITELN(' SHOULD ALL WEIGHTS W[i] BE SIMPLY 0 OR 1 ? (y or n) ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IF INPUT@ IN ['0','O','o','Y','y'] THEN
    BEGIN READLN;
    FOR I:=1 TO NBDESC DO MAT[I]:=1;
(*  WRITELN(' Yes ');                                           DEBUG *)
    END
ELSE
    BEGIN READLN;
(*  WRITELN(' No ');                                            DEBUG *)
    IF LANG=1 THEN WRITELN(' INSCRIVEZ LES VALEURS DE W[i] ')
    ELSE WRITELN(' TYPE IN  THE WEIGHTS W[i]   ');
    LECTURE(MAT,NBDESC);
    END;
END;   (* PREPARE W[I] *)

PROCEDURE PREPMATPART;
VAR I,J,K,DESC,ORDRE,NBMAT:INTEGER;
    P:LINK;
      X:REAL;
BEGIN
NEW(MATINT1);
NEW(MATINT2);
IF LANG=1 THEN BEGIN
WRITELN(' COMBIEN Y A-T-IL DE MATRICES DE SIMILARITES PARTIELLES ');
WRITELN(' DANS LE FICHIER "PART" ? '); END
ELSE WRITELN
(' HOW MANY PARTIAL SIMILARITY MATRICES DO YOU HAVE (File "PART")? ');
READLN(NBMAT);
(* WRITELN(NBMAT);                                             DEBUG *)
IF NBMAT > 0 THEN RESET(PART);              (* MODIFICATION 91.10.03 *)
REWRITE(TEMP);
FOR I:=1 TO NBMAT DO
      BEGIN
      READ(PART,DESC);
      READ(PART,ORDRE);
      MATINT1@[I]:=DESC;
      MATINT2@[I]:=ORDRE;
      K:=ORDRE*(ORDRE-1) DIV 2;
      FOR J:=1 TO K DO
            BEGIN
            READ(PART,X);
            IF ((X < 0)OR(X > 1)) THEN ERREUR(12,I,J);
            TEMP@:=X;PUT(TEMP);
            END;
      END;
NBMAT:=NBMAT+1;
MATINT1@[NBMAT]:=NBDESC+1;
MATINT2@[NBMAT]:=0;
PROCHAIN:=NIL;
FOR I:=NBMAT DOWNTO 1 DO
      BEGIN
      NEW(P);
      WITH P@ DO
            BEGIN
            LIEN:=PROCHAIN;
            INT1:=MATINT1@[I];
            INT2:=MATINT2@[I];
            END;
      PROCHAIN:=P;
      END;
DISPOSE(MATINT1);
DISPOSE(MATINT2);
END; (* FIN PREPARE MATRICES PARTIELLES *)

PROCEDURE PREPKI(VAR K:MAT0);
VAR I:INTEGER;
    X:REAL;
BEGIN
IF LANG=1 THEN WRITELN
(' VOULEZ-VOUS LA MEME VALEUR DE K[i] POUR TOUS LES DESCRIPTEURS? ')
ELSE
WRITELN(' DO YOU WANT THE SAME VALUE OF K[i] FOR ALL DESCRIPTORS? ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IF INPUT@ IN ['N','n'] THEN
      BEGIN READLN;
(*    WRITELN(' No ');                                       DEBUG *)
      IF LANG=1 THEN BEGIN
      WRITELN(' ENTREZ LES DIFFERENTES VALEURS K[i]');
      WRITELN(' Pour les descripteurs regis par une matrice de ');
 WRITELN(' similarites partielles, tapez des valeurs-bidon de K[I]');
      END ELSE BEGIN
      WRITELN(' TYPE IN  THE VARIOUS K[i]   ');
      WRITELN(' For descriptors with partial similarity matrices, ');
      WRITELN(' type dummy values of K[i] ');
      END;
      LECTURE(K,NBDESC);
      END
ELSE
      BEGIN READLN;
(*    WRITELN(' Yes ');                                      DEBUG *)
IF LANG=1 THEN WRITELN(' ENTREZ LA VALEUR DE K[i] (une seule valeur)')
ELSE  WRITELN(' TYPE IN  THE VALUE FOR K[i] (one value only) ');
      READLN(X);
(*    WRITELN(X);                                            DEBUG *)
      FOR I:=1 TO NBDESC DO K[I]:=X;
      END;
END;   (* FIN PREPARE K[I] *)

PROCEDURE PREPMULTICLASS(VAR MULTCLASS:MATBOOL);
VAR I,J,K:INTEGER;
BEGIN
FOR I:=1 TO NBDESC DO MULTCLASS[I]:=FALSE;
IF LANG=1 THEN
WRITELN(' Combien y a-t-il de descripteurs QUALITATIFS multi-classes?')
ELSE
WRITELN(' How many multi-state QUALITATIVE descriptors are there? ');
READLN(J);
(* WRITELN(J);                                             DEBUG *)
IF J > 0 THEN
      BEGIN
      IF LANG=1 THEN WRITELN
      (' ENTREZ LES NUMEROS IDENTIFIANT CES DESCRIPTEURS ')
      ELSE WRITELN
      (' TYPE IN THE IDENTIFICATION NUMBERS OF THESE DESCRIPTORS ');
      FOR I:=1 TO J DO
            BEGIN
            READ(K);
(*          WRITE(K);                                      DEBUG *)
            MULTCLASS[K]:=TRUE;
            END;
(*    WRITELN;                                             DEBUG *)
      END;
END;     (* FIN DE PREPARATION MULTICLASSES *)

PROCEDURE PREPGROUPES(VAR MAT:MATINT;VAR NBGROUPES:INTEGER);
VAR I:INTEGER;
BEGIN
IF LANG=1 THEN
WRITELN(' ENTREZ LA CARDINALITE DE CHAQUE GROUPE, DANS L''ORDRE ')
ELSE WRITELN(' TYPE IN  THE CARDINALITY OF EACH GROUP, IN ORDER ');
NBGROUPES:=0;
I:=0;
WHILE I < NOBJ DO
      BEGIN
      NBGROUPES:=NBGROUPES+1;
      READ(MAT[NBGROUPES]);
(*    WRITE(MAT[NBGROUPES]);                                    DEBUG *)
      I:=I+MAT[NBGROUPES];
      END;
(* WRITELN;                                                     DEBUG *)
IF I > NOBJ THEN ERREUR(5,0,0);
END;   (* PREPARE GROUPES *)

PROCEDURE INIT(NOBJ:INTEGER;VAR FICH:MULTFICH);
VAR I:INTEGER;
BEGIN
ECRITINT(NOBJ,FICH);
ECRITINT(NBDESC,FICH);
FOR I:=1 TO 10 DO ECRITCHAR(TITRE[I],FICH);
DATE(DATE2);
FOR I:=1 TO 7 DO DATE1[I]:=DATE2[I];     (* CORRECTION VAX *)
FOR I:=8 TO 9 DO DATE1[I]:=DATE2[I+2];
DATE1[10]:=' ';
ECRITCHAR(DATE1,FICH);
ECRITCHAR(FONC,FICH);
FONC[10]:=')';
FONC[9]:='B';
FONC[8]:='O';
FONC[7]:='R';
FONC[6]:='P';
FONC[5]:='(';
ECRITCHAR(VIDE,FICH); (* EMPLOI FUTUR POUR AUTRES PROGRAMMES *)
IF IDENTLIGNE THEN
      BEGIN
      ECRITINT(1,FICH);
      IF NOT GROUPE THEN FOR I:=1 TO NOBJ DO ECRITCHAR(MATID@[I],FICH);
      END
ELSE ECRITINT(0,FICH); (*** LIGNES NON TITREES ***)
END;   (* FIN INIT *)

PROCEDURE PARAMETRES;
VAR I,J:INTEGER;
BEGIN
PROBABILITE:=FALSE;
RESET(ENTREEC);
REWRITE(SORTIE);
FOR I:=1 TO NBCHAR DO VIDE[I]:=' ';
IF LANG=1 THEN WRITELN(' TITRE: ') ELSE WRITELN(' TITLE: ');
FOR I:=1 TO 10 DO TITRE[I]:='          ';
I:=2;J:=1;
GET(INPUT);
WHILE ((NOT(EOLN(INPUT)))AND(J<=10)) DO
      BEGIN
      TITRE[J,I]:=INPUT@;
      GET(INPUT);
      I:=I+1;
      IF I > NBCHAR THEN
            BEGIN
            J:=J+1;
            I:=1;
            END;
      END;
READLN;
IF LANG=1 THEN WRITELN(' NOMBRE D''OBJETS (LIGNES)? ')
          ELSE WRITELN(' NUMBER OF OBJECTS (ROWS)?  ');
READ(NOBJ);READLN;
(* WRITELN(NOBJ);                                               DEBUG *)
IF LANG=1 THEN WRITELN(' NOMBRE DE DESCRIPTEURS (COLONNES)? ')
          ELSE WRITELN(' NUMBER OF DESCRIPTORS (COLUMNS)?   ');
READ(NBDESC);READLN;
(* WRITELN(NBDESC);                                             DEBUG *)
IF LANG=1 THEN WRITELN(' CODE REPRESENTANT L''ABSENCE D''INFORMATION? ')
          ELSE WRITELN(' CODE FOR MISSING VALUES?  ');
READ(ABSENCE);READLN;
(* WRITELN(ABSENCE);                                            DEBUG *)
IF LANG=1 THEN WRITELN
(' LES 10 PREMIERES COLONNES CONTIENNENT-ELLES LES NOMS DES OBJETS?',
                                                         ' (o ou n) ')
ELSE WRITELN
(' ARE THE FIRST 10 COLUMNS USED TO WRITE THE OBJECT NAME? (y or n) ');
WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
IDENTLIGNE:=INPUT@ IN['0','O','o','Y','y']; READLN;
(* IF IDENTLIGNE THEN WRITELN(' Yes ') ELSE WRITELN(' No ');    DEBUG *)
NBIDENT:=0;
IF IDENTLIGNE THEN NEW(MATID);
NUMEROTE(FONCTION);
IF FONCTION IN[30,50..58] THEN
      BEGIN
      IF LANG=1 THEN WRITELN
      (' DESIREZ-VOUS LES PROBABILITES ASSOCIEES (fichier PROBAB) ?')
      ELSE WRITELN
      (' DO YOU WANT THE ASSOCIATED PROBABILITIES? (file PROBAB)  ');
      WHILE NOT (INPUT@ IN ['0','O','o','Y','y','N','n']) DO GET(INPUT);
      PROBABILITE:=INPUT@ IN ['0','O','o','Y','y']; READLN;
(* IF PROBABILITE THEN WRITELN(' Yes ') ELSE WRITELN(' No ');   DEBUG *)
      END;
IF PROBABILITE THEN REWRITE(PROBAB);
IF GROUPE THEN
      BEGIN
      NEW(MATINT1);
      PREPGROUPES(MATINT1@,NBGROUPES);
      INIT(NBGROUPES,SORTIE);
      IF PROBABILITE THEN INIT(NBGROUPES,PROBAB);
      IF FONCTION=37 THEN
            BEGIN
            NEW(MAT1);
            NEW(MAT2);
            D12(MAT1@,MAT2@);
            END
      ELSE D05(NBDESC*(NBDESC+1) DIV 2);
      END
ELSE IF QUANTITATIF THEN
   BEGIN
   IF NBDESC > MAXCALCUL THEN ERREUR(7,0,0);
   IF EOF(ENTREEC) THEN ERREUR(1,0,0)
   ELSE BINARISE;
   INIT(NOBJ,SORTIE);
   IF PROBABILITE THEN INIT(NOBJ,PROBAB);
   IF IDENTLIGNE THEN DISPOSE(MATID);
   CASE FONCTION OF
      15,19:BEGIN
         NEW(MAT3);
         NEW(MAT4);
         PREPECART(MAT3@);
         PREPWI(MAT4@);
         IF FONCTION=15 THEN
            BEGIN
            NEW(MULTCLASS);
            PREPMULTICLASS(MULTCLASS@);
            END;
         END;
      16,20:BEGIN
         PREPMATPART;
         NEW(MAT3);
         PREPKI(MAT3@);
         NEW(MAT4);
         PREPWI(MAT4@);
         END;
      17,18:BEGIN END;
      21:BEGIN
         NEW(MAT3);
         SOMME(MAT3@);
         END;
      22:BEGIN
         IF LANG=1 THEN BEGIN
         WRITELN(' OPTIONS: CALCULER CETTE PROBABILITE A PARTIR     ');
         WRITELN('      1 - DU KHI CARRE DE PEARSON                 ');
         WRITELN('      2 - OU DU KHI CARRE DE WILKS (test G)       ');
         END ELSE BEGIN
         WRITELN(' OPTIONS: PROBABILITY COMPUTATION BASED UPON      ');
         WRITELN('      1 - PEARSON"S CHI SQUARE                    ');
         WRITELN('      2 - OR WILKS" CHI SQUARE, also called G test');
         END;
         WHILE NOT (INPUT@ IN ['1','2']) DO GET(INPUT);
         WILKS:=INPUT@ IN['2']; READLN;
(* IF WILKS THEN WRITELN(' Wilks') ELSE WRITELN(' Pearson');    DEBUG *)
         END;
      23:BEGIN
         REPEAT
            IF LANG=1 THEN BEGIN
            WRITELN(' OPTIONS: BASER LE CALCUL DE CE COEFFICIENT    ');
            WRITELN('      1 - SUR LE S19 DE GOWER                  ');
            WRITELN('      2 - SUR LE S17 DE STEINHAUS              ');
            END ELSE BEGIN
            WRITELN(' OPTIONS: BASE THE COMPUTATIONS ON             ');
            WRITELN('      1 - GOWER"s S19 COEFFICIENT              ');
            WRITELN('      2 - STEINHAUS" S17 COEFFICIENT           ');
            END;
            WRITELN('      ');READLN(OPTION);
         UNTIL OPTION IN[1,2];
(*       WRITELN(OPTION);                                       DEBUG *)
         TRANSPOSE;
         S23;
         END;
      26,27,28,29,32,33,34,35,36,37,38,39,51,59,0:BEGIN END;   (* Nei *)
      31:BEGIN
 IF LANG=1 THEN WRITELN(' PUISSANCE DE LA METRIQUE? (un nombre entier)')
           ELSE WRITELN(' POWER OF THE METRIC? (type an integer) ');
         READLN(PUISSANCE);
(*       WRITELN(PUISSANCE);                                    DEBUG *)
         END;
      50:BEGIN
         NEW(MAT3);
         NEW(MATINT1);
         REPEAT
               WRITELN(' OPTIONS 1: TAU A, B');
               WRITELN('         2: TAU A, B, C');
               WRITELN('         ');READLN(OPTION);
         UNTIL OPTION IN[1,2];
(*       WRITELN(OPTION);                                       DEBUG *)
         END;
      52:NEW(MAT3);
      53,54,55,56,57,58:BEGIN
         NEW(MAT3);
         NEW(MAT4);
         END;
      OTHERWISE
            IF LANG=1 THEN WRITELN(' PROGRAMME NON IMPLANTE ')
                      ELSE WRITELN(' PROGRAM NOT WRITTEN YET ');
            ERREUR(4,0,0);
      END;
   END
ELSE
      BEGIN
      PREPABS;
      INIT(NOBJ,SORTIE);
      IF IDENTLIGNE THEN DISPOSE(MATID);
      END;
END;   (* FIN PARAM *)

PROCEDURE CALCULE;
VAR I,J,K:INTEGER;
BEGIN
NEW(MAT1);
NEW(MAT2);
FOR I:=1 TO NOBJ DO
      BEGIN
      RESET(BIN);
      FOR J:=1 TO I-1 DO
         FOR K:=1 TO NBDESC  DO GET(BIN);
      FOR J:=1 TO NBDESC DO
            BEGIN
            MAT1@[J]:=BIN@;
            GET(BIN);
            END;
      FOR J:=I+1 TO NOBJ DO
            BEGIN
            FOR K:=1 TO NBDESC DO
                  BEGIN
                  MAT2@[K]:=BIN@;
                  GET(BIN);
                  END;
            FN(FONCTION,I,J);
            END;
      END;
END;   (* FIN CALCULE *)

PROCEDURE CALCULEABS(NBMOT:INTEGER);
VAR J,LIGNE1,LIGNE2,K,NOBJMOINS1:INTEGER;
    A,B,C,D,N,X:REAL;

   PROCEDURE CALCUL(VAR A,B,C,D:REAL);
   VAR J:INTEGER;
   VAR REFA,REFB,REFABS:ENS;
   BEGIN
   A:=0;B:=0;C:=0;D:=NBDESC;
   FOR J:=0 TO NBMOT DO
      BEGIN
      REFA:=MATB1@[J];
      REFB:=MATB2@[J];
      REFABS:=MATABS1@[J]+MATABS2@[J];
      A:=A+CARD((REFA*REFB)-REFABS);
      B:=B+CARD((REFA-REFB)-REFABS);
      C:=C+CARD((REFB-REFA)-REFABS);
      D:=D-CARD(REFABS);
      END;
   D:=D-A-B-C;
   END;    (* CALCUL A,B,C,D *)

BEGIN
NEW(MATB1);NEW(MATB2);NEW(MATABS1);NEW(MATABS2);
RESET(BINTEMP);
NOBJMOINS1:=NOBJ-1;
FOR LIGNE1:=1 TO NOBJMOINS1 DO
      BEGIN
      RESET(BINTEMP);
      FOR J:=1 TO LIGNE1-1 DO
            FOR K:=0 TO NBMOT DO BEGIN GET(BINTEMP);GET(BINTEMP);END;
      FOR J:=0 TO NBMOT DO
            BEGIN
            MATB1@[J]:=BINTEMP@;GET(BINTEMP);
            MATABS1@[J]:=BINTEMP@;GET(BINTEMP);
            END;
      FOR LIGNE2:=LIGNE1+1 TO NOBJ DO
            BEGIN
            FOR K:=0 TO NBMOT DO
                  BEGIN
                  MATB2@[K]:=BINTEMP@;GET(BINTEMP);
                  MATABS2@[K]:=BINTEMP@;GET(BINTEMP);
                  END;
            CALCUL(A,B,C,D);
            N:=A+B+C;
            X:=0;
      IF ((N=0) AND (((FONCTION>6) AND (FONCTION<25)) OR (FONCTION=38)))
            THEN  ERRNONFAT(2,LIGNE1,LIGNE2)
            ELSE CASE FONCTION OF
                0:X:=S00(A,B,C,D,A+B+C+D);
                1:X:=(A+D)/(A+B+C+D);
                2:X:=(A+D)/(A+2*B+2*C+D);
                3:X:=2*(A+D)/(2*(A+D)+B+C);
                4:IF B+C > 0 THEN X:=(A+D)/(B+C);
                5:IF (((A+B > 0)AND(A+C > 0))
                     AND ((A+D > 0)AND(B+D > 0))) THEN
                          X:=(A/(A+B)+A/(A+C)+D/(B+D)+D/(C+D))/4;
                6:BEGIN
                    X:=SQRT((A+B)*(A+C)*(B+D)*(C+D));
                    IF X>0 THEN X:=A*D/X;
                    END;
                7:X:=A/(A+B+C);
                8:X:=2*A/(2*A+B+C);
                9:X:=3*A/(3*A+B+C);
               10:X:=A/(A+2*(B+C));
               11:X:=A/(A+B+C+D);
               12:IF B+C > 0 THEN X:=A/(B+C);
               13:IF A > 0 THEN X:=(A/(A+B)+A/(A+C))/2;
               14:IF A > 0 THEN X:=A/SQRT((A+B)*(A+C));
                  24:BEGIN
                     IF A > 0 THEN
                           BEGIN
                           IF B > C THEN C:=B;
                           X:=A/SQRT((A+B)*(A+C))-1/SQRT(A+C)*0.5;
                           END;
                     END;
                  25:BEGIN
                     N:=A+B+C+D;
                     IF (A+B)*(A+C)/N < A THEN
                        BEGIN
                        IF (((A<5)OR(B<5))OR(((B<5)OR(D<5))OR(N<20)))
                           THEN X:=1-FISHER(A,B,C,D)
                        ELSE
                           BEGIN
                           X:=N*SQR(ABS(A*D-B*C)-N/2)/
                            ((A+B)*(C+D)*(A+C)*(B+D));
                           X:=1-CHIPROB(X,1,FALSE,WRONG);
                           END;
                        END;
                     END;
                  26:X:=(A+D/2)/(A+B+C+D);
                  38:X:=(B+C)/(2*A+B+C);
                 END;
          ECRITREEL(X,SORTIE);
            END;
      END;
END;   (* FIN DE CALCUL PRESENCE ABSENCE *)


BEGIN (* PROG PRINC *)
WRITELN;
IF LANG=1 THEN BEGIN
WRITELN(' S I M I L : Calcul de matrices de ressemblance.          ');
WRITELN;
WRITELN(' VERSION 3.0b');
WRITELN(' AUTEUR: A. VAUDOR');
WRITELN(' REFERENCE: Chapitre 7 de ');
WRITELN(' Legendre, L. et P. Legendre.  1984 -- Ecologie numerique, ');
WRITELN('     2ieme edition. Tome 2: La structure des donnees ecol- ');
WRITELN('     giques. Collection d''Ecologie, 13.  Masson, Paris  et ');
WRITELN('     les Presses de l''Universite du Quebec.  viii + 335 p. ');
END ELSE BEGIN
WRITELN(' S I M I L : A program for computing resemblance matrices ');
WRITELN;
WRITELN(' VERSION 3.0b');
WRITELN(' AUTHOR: A. VAUDOR');
WRITELN(' REFERENCE: Chapter 6 of ');
WRITELN(' Legendre, L. and P. Legendre. 1983 -- Numerical ecology. ');
WRITELN('     Developments in Environmental Modelling, 3. Elsevier ');
WRITELN('     Scientific Publ. Co., Amsterdam. xvi + 419 p.        ');
END;
WRITELN;WRITELN;
PARAMETRES;
IF NOT((GROUPE)OR(FONCTION=23)) THEN
      BEGIN
      IF QUANTITATIF THEN CALCULE
      ELSE CALCULEABS(NBMOT);
      END;
IF PROBABILITE THEN
      IF LANG=1 THEN WRITELN(' [FICHIER DE SORTIE: PROBAB ] ')
                ELSE WRITELN(' [OUTPUT FILE: PROBAB ]');
777:  IF LANG=1 THEN WRITELN(' Fin du programme. ')
                ELSE WRITELN(' End of the program. ');
END.
